    MODULE CUPARM
!>--------------------------------------------------------------------------------------------------
!> MODULE CUPARM
!>
!> ABSTRACT:
!> AUGUST 91: SCHEME HAVING THE OPTION OF USING DIFFERENT FAST AND SLOW PROFILES FOR SEA AND FOR 
!> LAND POINTS; AND ALSO THE "SEA" AND THE "LAND" SCHEME EVERYWHERE.
!> OVER LAND PROFILES DEPART FROM THE FAST (DRY) PROFILES ONLY FOR PRECIPITATION/TIME STEP .GT. A 
!> PRESCRIBED VALUE (CURRENTLY, IN THE VERSION #3 DONE WEDNESDAY 18 SEPTEMBER, 1/4 INCH/24 H).
!> USE OF VARIOUS SWITCHES AS FOLLOWS.
!>
!> THE "OLD" ("HARD", = ZAVISA OCT. 1990) LAND SCHEME WITH FIXED LAND PROFILES IS RUN BY:
!>
!> - SETTING OCT90 = .TRUE. IN THE FIRST EXECUTABLE LINE FOLLOWING THESE COMMENTS (THIS REACTIVATES
!>   EFI=1. OVER LAND IF .NOT. UNIS, AND CLDEFI(K) = EFIMN AS THE LEFTOVER CLDEFI VALUE AT SWAP 
!>   POINTS)
!> - DEFINING FAST LAND PROFILES SAME AS FAST SEA PROFILES (OR BY CHOOSING ANOTHER SET OF LAND 
!>   PROFILES ZAVISA USED AT EARLIER TIME)
!> - SETTING FSL = 1.
!> - DEFINING STEFI (STARTING EFI) EQUAL TO AVGEFI. (THE LAST THREE POINTS ARE HANDLED BY SWITCHING
!>   AROUND THE "CFM" COMMENTS AT TWO PLACES)
!>
!> THE "OLD,OLD" (APPR. ORIGINAL BETTS) SCHEME IS RUN BY:
!> - SPECIFYING UNIL=.TRUE.;
!> - SETTING FSL=1.;
!> - SETTING OCT90=.TRUE. (WITH THESE SETTINGS FAST LAND PROFILES ONLY ARE USED).
!>
!> IN THIS VERSION 3.5, OVER LAND AND FOR THE FAST PROFILES, DSPB IS PRESCRIBED TO BE 25 PERCENT 
!> DRIER THAN THE FAST SEA VALUE (IN ROUGH AGREEMENT WITH BINDER, QJ, IN PRESS) WHILE DSP0 AND
!> DSPT ARE EACH 20 PERCENT DRIER THAN THE CORRESPONDING FAST SEA VALUES.
!> WITH FSL = .875 THIS MAKES THE AVERAGE OF THE FAST AND THE SLOW LAND PROFILES SOMEWHAT DRIER THAN
!> THE OCT90 FIXED LAND PROFILES.
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : CUCNVC
!>              INIT
!>              INITS
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CP     = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: CAPA   =    0.28589641
    REAL   (KIND=R4KIND), PARAMETER :: ELWV   =    2.50E6
    REAL   (KIND=R4KIND), PARAMETER :: ELIVW  =    2.72E6 
    REAL   (KIND=R4KIND), PARAMETER :: ROW    =    1.E3  
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: A2     =   17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3     =  273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4     =   35.86
    REAL   (KIND=R4KIND), PARAMETER :: TFRZ   =  273.15
    REAL   (KIND=R4KIND), PARAMETER :: T1     =  274.16
    REAL   (KIND=R4KIND), PARAMETER :: PQ0    =  379.90516 
    REAL   (KIND=R4KIND), PARAMETER :: STRESH =    1.10
!
    END MODULE CUPARM
